\begin{code}
{-# OPTIONS --cubical --safe #-}
module _ where

open import Cubical.Foundations.Prelude

open import Cubical.Data.Nat

infixr 5 _∷_
infixr 5 _++_

private
  variable
    ℓ : Level
\end{code}

%<*vec>
\begin{code}
data Vec (A : Set ℓ) : ℕ → Set ℓ where
  []  : Vec A zero
  _∷_ : ∀ {n} (x : A) (xs : Vec A n) → Vec A (suc n)
\end{code}
%</vec>

%<*concat>
\begin{code}
_++_ : {A : Set ℓ} {m n : ℕ} → Vec A m → Vec A n → Vec A (m + n)
[]       ++ ys = ys
(x ∷ xs) ++ ys = x ∷ (xs ++ ys)
\end{code}
%</concat>

%<*concatassoc>
\begin{code}
++-assoc : {A : Set ℓ} {m n k : ℕ} (xs : Vec A m) (ys : Vec A n) (zs : Vec A k) →
           PathP (λ i → Vec A (+-assoc m n k i))
                 (xs ++ (ys ++ zs)) ((xs ++ ys) ++ zs)
++-assoc {m = zero} [] ys zs = refl
++-assoc {m = suc m} (x ∷ xs) ys zs i = x ∷ ++-assoc xs ys zs i
\end{code}
%</concatassoc>
